{ ... }@args:

with builtins;

let
  fix = f: let x = f x; in x;

  readTree = import ./nix/readtree {};

  # Tracking nixos-unstable as of 2021-08-11.
  nixpkgsCommit = "e26c0ffdb013cd378fc2528a44689a8bf35d2a6c";
  nixpkgsSrc = fetchTarball {
    url = "https://github.com/NixOS/nixpkgs/archive/${nixpkgsCommit}.tar.gz";
    sha256 = "1b33hw35fqb9rzszdg5jpiyfvhx2cxpv0qrkyr19zkdpdahzdbss";
  };
  nixpkgs = import nixpkgsSrc {
    config.allowUnfree = true;
    config.allowBroken = true;
  };

  resForPkgs = pkgs: fix (self: (readTree rec {
    hscloud = self;
    inherit pkgs;
    pkgsSrc = pkgs.path;
    inherit (pkgs) lib stdenv;
    hscloudForPkgs = pkgs: resForPkgs pkgs;
  } ./.));

in (resForPkgs nixpkgs) // {
  root = ./.;
  pkgs = nixpkgs;
}
